/*   *********************************************************************   */
/*   REXX                                                                    */
/*   (C) Copyright norrsken-data-teknik                                      */
/*   helge nordmann                                                          */
/*   2002                                                                    */
/*   http://www.norrsken-data-teknik.com                                     */
/*   *********************************************************************   */
'@echo off'
esc= D2C(27)
say esc'[0;37;46m'esc'[K'esc'[2J' /* white on green */
vers = '2002-01-11'
source_file = ''
target = ''

/*   the default target directory -- please edit the following line          */
/*   according to Your needs (the path MUST end with a \  (backslash))       */
default_target = 'D:\ZipUnZip\Zipped\'

/*   here we go...                                                           */

say ''
say 'norrsken data teknik'
say ''
say 'ZipDir version' vers
say ''

/*   the usual stuff                                                         */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/*   parsing arguments                                                       */

dir_name = ''
parse arg source_dir dir_name target

/*   usage info                                                              */

if (source_dir = '' | source_dir = '?') then do
  say ''
  say 'Usage:'
  say 'ZipDir <source_directory> [name_of_zip_file [target_directory]]'
  say ''
  say '<>   required parameter'
  say '[]   optional parameter'
  say ''
  say '<source_directory> might be a drive'
  say ''
  say 'f.e.: ZipDir D:\Quark'
  say 'zippes the whole D:\Quark directory to a file Quark.zip'
  say ''
  say 'ZipDir D:\Quark krauQ C:\temp'
  say 'zippes the whole D:\Quark directory to a file krauQ.zip'
  say 'placed in C:\temp'
  say ''
  say 'press Enter to continue...'
  parse pull dummy
  exit
  end

say 'now trying to zip the 'source_dir' directory'
say ''

if (LASTPOS('\', source_dir) \= LENGTH(source_dir)) then do
  source_dir = source_dir||'\'
  end

this_drive  = filespec( 'drive', source_dir )
this_path   = filespec( 'path', source_dir )

this_in = this_drive || this_path

this_path = LEFT(this_path, LENGTH(this_path) -1)

pos = LASTPOS('\', this_path)
pos = pos +1

if (dir_name = '') then do
  dir_name = SUBSTR(this_path, pos, LENGTH(this_path) -pos +1)
  end

if (dir_name = '') then do
  dir_name = 'Drive_' || LEFT(this_drive, 1)
  end

say 'with the name 'dir_name
say ''

if (target = '') then do
  target = default_target
  end

say 'to the 'target' directory...'
say ''

/*   now zip it all                                                          */

command = 'zip ' || '-g -r -S -b ' || this_in || ' ' || target || '' 
command = command || dir_name || '.zip ' || this_in || '*.*'

say command
command

say ''
say 'done'
say ''

exit

