/*   *********************************************************************   */
/*   xdel                                                                    */
/*                                                                           */
/*   Copyright                                                               */
/*   norrsken data teknik                                                    */
/*   (helge nordmann)                                                        */
/*   2001-12-14                                                              */
/*                                                                           */
/*   adding the x del command to OS/2, eCS                                   */
/*   compare commands to 'xcopy'                                             */
/*                                                                           */
/*   put this file in a directory in a path (f.e.: C:\OS2)                   */
/*                                                                           */
/*   for now there are the parameter                                         */
/*   /S   work on subdirectories                                             */
/*   /A   reset the attributes a s r h                                       */
/*   /EA  remove only the EAs                                                */
/*   available...                                                            */
/*                                                                           */
/*   Changes:                                                                */
/*   2002-02-06   changed parse arg to parse UPPER arg                       */
/*                avoiding deleting directories by mistake, /a instead of /A */
/*                                                                           */
esc= D2C(27)
say esc'[0;37;46m'esc'[K'esc'[2J' /* white on green */

/*   the usual stuff                                                         */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/*   defining some variables                                                 */
path = ''
params1 = ''
params2 = ''
vers = '2002-02-06'
searchOption = 'FO'
searchOptionD = 'DO'
searchOptionEA = 'BO'
attDelete = 'false'
eaDelete = 'false'

/*   get the command(s)                                                      */
parse arg path params1 params2
params1 = translate(params1)
params2 = translate(params2)

/*   user info -- in case of wrong usage                                     */
if (path = '' | (0 < POS('/', path))) then do
  say ''
  say 'xdel (by norrsken data teknik) -- version 'vers
  say ''
  say 'Usage: xdel <complete path> [parameter]'
  say ''
  say 'Parameter list:'
  say '/S   scan subdirectories'
  say '/A   reset the a s h r attributes'
  say '/EA  remove only the EAs'
  say '     (without /EA or /A the whole directory tree will be deleted)'
  say ''
  say 'Given command was xdel 'path' 'params1' 'params2
  say ''
  say 'Press Enter to continue'
  parse pull dummy
  exit
  end

/*   translate parameters to commands                                        */
if (0 < POS('/S', params1) | 0 < POS('/S', params2)) then do
  searchOption = 'SFO'
  searchOptionD = 'SDO'
  searchOptionEA = 'SBO'
  end /* POS /S */

if (0 < POS('/EA', params1) | 0 < POS('/EA', params2)) then do
  eaDelete = 'true'
  end /* POS /S */

if (0 < POS('/A', params1) | 0 < POS('/A', params2)) then do
  attDelete = 'true'
  end /* POS /S */

pathf = path||'\*'
pathd = path||'\*'

/*   do it                                                                   */
/*   delete the files and directories (eaDelete==false)                      */

if (eaDelete = 'false' & attDelete = 'false') then do
/*   1. the files                                                            */

call SysFileTree ''pathf'' , found. , searchOption

do i=1 to found.0

  command = 'attrib -h -r -s -a '
  command = command || " " || '"'found.i'"'
  command

  command = 'del '
  command = command || " " || '"'found.i'"'
  say command
  command

  end /* i++ */

/*   now delete the directories                                              */

call SysFileTree ''pathd'' , found. , searchOptionD

do j=1 to found.0
  i = found.0 - j + 1 /* this is a REXX bug fix for 'step -1' */

  command = 'attrib -h -r -s -a '
  command = command || " " || '"'found.i'"'
  command

  command = 'rd '
  command = command || '"'found.i'"'
  say command
  command

  end /* i++ */

command = 'attrib -h -r -s -a '
command = command || '"'path'"'
command

command = 'rd '
command = command || '"'path'"'
say command
command

/*   eaDelete == false *** eaDelete == true                                  */
end /* file; directory delete */
else do
/*   list the files and delete the EAs                                       */
/*   or reset the a s h r attributes                                         */

/*   delete the EAs                                                          */
if (eaDelete = 'true') then do

  call SysFileTree ''pathf'' , found. , searchOptionEA

  do i=1 to found.0

    command = 'attrib -h -r -s -a '
    command = command || " " || '"'found.i'"'
    command

    command = 'eautil '
    command = command || ' ' || '"'found.i'"' || ' dummy.ea /S '
    command

    command = 'del '
    command = command || 'dummy.ea '
    command

    end /* i++ */
  end /* ea delete */

/*   reset the attributes                                                  */
if (attDelete = 'true') then do

  call SysFileTree ''pathf'' , found. , searchOptionD

  do i=1 to found.0

    command = 'attrib -h -r -s -a '
    command = command || " " || '"'found.i'"\*.*'
    command

    end /* i++ */

  command = 'attrib -h -r -s -a '
  command = command || " " || '"' || pathf || '.*"'
say  command

  end /* ea delete */

end /* !delete fies */
/*   done                                                                    */
exit
/*   *********************************************************************   */
